(require (lib "trace.ss")
         (lib "turtles.ss" "graphics"))

(define maxhoehe 200)
(define maxbreite 300)

(define zufzahl
  (lambda (max)
    (+ 1 (random max))))

(define raten
  (lambda (max)
    (letrec
        ([suche
          (lambda (z anzahl)
            (printf "Deine Vermutung: ")
            (let ([zahl (read)])
              (cond
                [(= z zahl) (printf "Glckwunsch, Du hast ~s mit ~s Versuch(en) erraten! ~n" zahl anzahl)]
                [(< z zahl) (printf "--> ~s ist zu gro! ~n" zahl) (suche z (+ 1 anzahl))]
                [else
                 (printf "--> ~s ist zu klein! ~n" zahl) (suche z (+ 1 anzahl))])))])
      (suche (zufzahl max) 1))))

(define computerraten
  (lambda (max)
    (letrec
        ([suche
          (lambda (li z re)
            (let ([mi (quotient (+ li re) 2)])
              (cond
                [(= z mi) (list z)]
                [(< z mi) (cons mi (suche li z mi))]
                [else
                 (cons mi (suche mi z re))])))])
      (let ([liste (suche 1 (zufzahl max) (+ max 1))])
        (printf "Suche : ~s ~n" liste)
        (printf "Anzahl: ~s ~n" (length liste))))))

(define computerraten-anzahl
  (lambda (max)
    (letrec
        ([suche
          (lambda (li z re)
            (let ([mi (quotient (+ li re) 2)])
              (cond
                [(= z mi) 1]
                [(< z mi) (+ 1 (suche li z mi))]
                [else
                 (+ 1 (suche mi z re))])))])
      (suche 1 (zufzahl max) (+ max 1)))))

(define computerraten-wdhlg
  (lambda (max anzahl)
    (letrec
        ([wiederhole
          (lambda (n)
            (if (< n 1)
                0
                (+ (computerraten-anzahl max) (wiederhole (- n 1)))))]) 
      (/ (wiederhole anzahl) anzahl))))
       
(define saeule
  (lambda (hoehe breite)
    (draw breite)(turn 90)
    (draw hoehe)(turn 90)
    (draw breite)(turn 90)
    (draw hoehe)(turn 90)
    (draw breite)))

(define saeulendiagramm
  (lambda (ls)
    (let ([breite (/ maxbreite (length ls))])
      (letrec
          ([zeichnen
            (lambda (max ls)
              (if (not (null? ls))
                  (begin
                    (saeule (* (/ (car ls) max) maxhoehe) breite)
                    (zeichnen max (cdr ls)))))])
        (turtles #t) (clear)
        (draw (- (/ maxbreite 2)))
        (zeichnen (maximum ls) ls)))))

(define maximum
  (lambda (ls)
    (letrec
        ([maxsuche
          (lambda (max ls)
            (cond
              [(null? ls) max]
              [(< max (car ls)) (maxsuche (car ls) (cdr ls))]
              [else
               (maxsuche max (cdr ls))]))])
      (maxsuche (car ls) (cdr ls)))))

(define grafik
  (lambda (minanzahl maxanzahl schritt wdhlg)
    (letrec
        ([durchfuehren
          (lambda (min)
            (if (> min maxanzahl)
                ()
                (cons (computerraten-wdhlg min wdhlg) (durchfuehren (+ min schritt)))))])
      (let ([ls (durchfuehren minanzahl)])
        (saeulendiagramm ls)
        ls))))

;Aufrufbeispiel: (grafik 200 10000 200 1000)
